"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ECharts = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeWebview = require("react-native-webview");

var jsBuilder = _interopRequireWildcard(require("./jsBuilder"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const styles = {
  container: {
    flex: 1
  }
};

class ECharts extends _react.PureComponent {
  componentDidUpdate(prevProps) {
    if (prevProps.option !== this.props.option && this.props.option) {
      this.webview.injectJavaScript(jsBuilder.getJavascriptSource(this.props));
    }
  }

  constructor(props) {
    super(props);

    _defineProperty(this, "callbacks", void 0);

    _defineProperty(this, "onGetHeight", void 0);

    _defineProperty(this, "webview", void 0);

    _defineProperty(this, "onMessage", e => {
      try {
        if (!e) return null;
        const {
          onData
        } = this.props;
        const data = JSON.parse(unescape(unescape(e.nativeEvent.data)));

        if (data.types === 'DATA') {
          if (onData) {
            onData(data.payload);
          }
        } else if (data.types === 'CALLBACK') {
          const {
            uuid
          } = data;
          this.callbacks[uuid](data.payload);
        }
      } catch (error) {
        console.log(error);
      }

      return null;
    });

    _defineProperty(this, "postMessage", data => {
      if (this.webview) {
        this.webview.postMessage(jsBuilder.convertToPostMessageString(data));
      }
    });

    _defineProperty(this, "ID", () => "_".concat(Math.random().toString(36).substr(2, 9)));

    _defineProperty(this, "setBackgroundColor", color => {
      const data = {
        types: 'SET_BACKGROUND_COLOR',
        color
      };
      this.postMessage(data);
    });

    _defineProperty(this, "getOption", (callback, properties = undefined) => {
      const uuid = this.ID();
      this.callbacks[uuid] = callback;
      const data = {
        types: 'GET_OPTION',
        uuid,
        properties
      };
      this.postMessage(data);
    });

    _defineProperty(this, "setOption", (option, notMerge, lazyUpdate) => {
      const data = {
        types: 'SET_OPTION',
        payload: {
          option,
          notMerge: notMerge || false,
          lazyUpdate: lazyUpdate || false
        }
      };
      this.postMessage(data);
    });

    _defineProperty(this, "clear", () => {
      const data = {
        types: 'CLEAR'
      };
      this.postMessage(data);
    });

    _defineProperty(this, "getWebViewRef", ref => {
      this.webview = ref;
    });

    _defineProperty(this, "onLoadEnd", () => {
      if (this.webview) {
        this.webview.injectJavaScript(jsBuilder.getJavascriptSource(this.props));
      }

      if (this.props.onLoadEnd) {
        this.props.onLoadEnd();
      }
    });

    this.onGetHeight = undefined;
    this.callbacks = {};
  }

  render() {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.container
    }, /*#__PURE__*/_react.default.createElement(_reactNativeWebview.WebView, _extends({}, this.props, {
      ref: this.getWebViewRef,
      originWhitelist: ['*'],
      scrollEnabled: false,
      onMessage: this.onMessage,
      allowFileAccess: true,
      allowUniversalAccessFromFileURLs: true,
      mixedContentMode: "always",
      onLoadEnd: this.onLoadEnd
    })));
  }

}

exports.ECharts = ECharts;

_defineProperty(ECharts, "defaultProps", {
  onData: () => {},
  canvas: false,
  onLoadEnd: () => {},
  backgroundColor: 'rgba(0, 0, 0, 0)'
});
//# sourceMappingURL=index.js.map