function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { PureComponent } from 'react';
import { View } from 'react-native'; // @ts-ignore

import { WebView } from 'react-native-webview';
import * as jsBuilder from './jsBuilder';
const styles = {
  container: {
    flex: 1
  }
};

class ECharts extends PureComponent {
  componentDidUpdate(prevProps) {
    if (prevProps.option !== this.props.option && this.props.option) {
      this.webview.injectJavaScript(jsBuilder.getJavascriptSource(this.props));
    }
  }

  constructor(props) {
    super(props);

    _defineProperty(this, "callbacks", void 0);

    _defineProperty(this, "onGetHeight", void 0);

    _defineProperty(this, "webview", void 0);

    _defineProperty(this, "onMessage", e => {
      try {
        if (!e) return null;
        const {
          onData
        } = this.props;
        const data = JSON.parse(unescape(unescape(e.nativeEvent.data)));

        if (data.types === 'DATA') {
          if (onData) {
            onData(data.payload);
          }
        } else if (data.types === 'CALLBACK') {
          const {
            uuid
          } = data;
          this.callbacks[uuid](data.payload);
        }
      } catch (error) {
        console.log(error);
      }

      return null;
    });

    _defineProperty(this, "postMessage", data => {
      if (this.webview) {
        this.webview.postMessage(jsBuilder.convertToPostMessageString(data));
      }
    });

    _defineProperty(this, "ID", () => "_".concat(Math.random().toString(36).substr(2, 9)));

    _defineProperty(this, "setBackgroundColor", color => {
      const data = {
        types: 'SET_BACKGROUND_COLOR',
        color
      };
      this.postMessage(data);
    });

    _defineProperty(this, "getOption", (callback, properties = undefined) => {
      const uuid = this.ID();
      this.callbacks[uuid] = callback;
      const data = {
        types: 'GET_OPTION',
        uuid,
        properties
      };
      this.postMessage(data);
    });

    _defineProperty(this, "setOption", (option, notMerge, lazyUpdate) => {
      const data = {
        types: 'SET_OPTION',
        payload: {
          option,
          notMerge: notMerge || false,
          lazyUpdate: lazyUpdate || false
        }
      };
      this.postMessage(data);
    });

    _defineProperty(this, "clear", () => {
      const data = {
        types: 'CLEAR'
      };
      this.postMessage(data);
    });

    _defineProperty(this, "getWebViewRef", ref => {
      this.webview = ref;
    });

    _defineProperty(this, "onLoadEnd", () => {
      if (this.webview) {
        this.webview.injectJavaScript(jsBuilder.getJavascriptSource(this.props));
      }

      if (this.props.onLoadEnd) {
        this.props.onLoadEnd();
      }
    });

    this.onGetHeight = undefined;
    this.callbacks = {};
  }

  render() {
    return /*#__PURE__*/React.createElement(View, {
      style: styles.container
    }, /*#__PURE__*/React.createElement(WebView, _extends({}, this.props, {
      ref: this.getWebViewRef,
      originWhitelist: ['*'],
      scrollEnabled: false,
      onMessage: this.onMessage,
      allowFileAccess: true,
      allowUniversalAccessFromFileURLs: true,
      mixedContentMode: "always",
      onLoadEnd: this.onLoadEnd
    })));
  }

}

_defineProperty(ECharts, "defaultProps", {
  onData: () => {},
  canvas: false,
  onLoadEnd: () => {},
  backgroundColor: 'rgba(0, 0, 0, 0)'
});

export { ECharts };
//# sourceMappingURL=index.js.map