import { Platform } from 'react-native';
export const convertToPostMessageString = obj => {
  return JSON.stringify(obj, (_key, val) => {
    if (typeof val === 'function') {
      // eslint-disable-next-line no-new-func
      return new Function('return ' + val.toString());
    }

    return val;
  });
};
export const toString = obj => {
  if (obj === undefined) return JSON.stringify({});
  return JSON.stringify(obj, (_key, val) => {
    if (typeof val === 'function') {
      return val.toString();
    }

    return val;
  });
};
export const getJavascriptSource = props => {
  const {
    OS
  } = Platform;
  const renderer = 'canvas';
  return "\n             var chart = echarts.init(document.getElementById('main'), undefined, {renderer: '".concat(renderer, "'});\n            chart.setOption(parse(decodeURI(\"").concat(encodeURI(toString(props.option)), "\")));\n             setBackgroundColor(\"").concat(props.backgroundColor, "\");\n\n             function setBackgroundColor(color) {\n                document.getElementById('main').style.backgroundColor = color;\n              }\n\n              function sendData(data) {\n                  window.ReactNativeWebView.postMessage(JSON.stringify({\"types\":\"DATA\",\"payload\": data}));\n              }\n\n              function sendCallbackData(uuid, data) {\n                  window.ReactNativeWebView.postMessage(JSON.stringify({\"types\":\"CALLBACK\", \"uuid\": uuid, \"payload\": data}));\n              }\n\n              function getOS() {\n                  return ").concat(OS, ";\n              }\n\n              function parse (data) {\n                  return JSON.parse(data, function (key, value) {\n\n                      if (value\n                          && typeof value === \"string\"\n                          && value.substr(0,8) === \"function\") {\n\n                          var startBody = value.indexOf('{') + 1;\n                          var endBody = value.lastIndexOf('}');\n                          var startArgs = value.indexOf('(') + 1;\n                          var endArgs = value.indexOf(')');\n\n                          return new Function(value.substring(startArgs, endArgs)\n                                            , value.substring(startBody, endBody));\n                      }\n                      return value;\n                  });\n              }\n\n              function toString (obj) {\n                  var result = JSON.stringify(obj, function (key, val) {\n                    if (typeof val === 'function') {\n                      return val.toString();\n                    }\n                    return val;\n                  });\n\n                  return result;\n              };\n\n              window.onresize = function() {\n                  chart.resize();\n              };\n\n              function processMessage (e) {\n                var req = parse(e.data);\n\n                switch(req.types) {\n                  case \"SET_OPTION\":\n                    chart.setOption(req.payload.option, req.payload.notMerge,req.payload.lazyUpate);\n                    break;\n                  case \"CLEAR\":\n                    chart.clear();\n                    break;\n                  case \"SET_BACKGROUND_COLOR\":\n                    setBackgroundColor(req.color);\n                    break;\n                  case \"GET_OPTION\":\n                    var option = chart.getOption();\n                    var data = {};\n\n                    if(req.properties !== undefined) {\n                        req.properties.forEach(function (prop) {\n                          data[prop] = option[prop];\n                        });\n                    } else {\n                        var data = {\n                            option: option\n                         };\n                    }\n\n                    sendCallbackData(req.uuid, data);\n                    break;\n                  default:\n                    break;\n                }\n              }\n\n              window.document.addEventListener('message', function(e) {\n                processMessage(e);\n              });\n\n              window.addEventListener('message', function(e) {\n                processMessage(e);\n              });\n\n              ").concat(props.additionalCode, "\n        ");
};
//# sourceMappingURL=jsBuilder.js.map