import { PureComponent } from 'react';
import { WebView, WebViewProps } from 'react-native-webview';
export declare type Props = WebViewProps & {
    onData?: (payload?: any) => void;
    canvas?: boolean;
    onLoadEnd?: () => void;
    backgroundColor?: string;
    option: Record<string, any>;
    additionalCode?: string;
};
declare class ECharts extends PureComponent<Props> {
    callbacks: Record<string, any>;
    onGetHeight?: () => void;
    webview: WebView | undefined;
    static defaultProps: {
        onData: () => void;
        canvas: boolean;
        onLoadEnd: () => void;
        backgroundColor: string;
    };
    componentDidUpdate(prevProps: Props): void;
    constructor(props: Props);
    onMessage: (e?: {
        nativeEvent: {
            data: string;
        };
    } | undefined) => null;
    postMessage: (data: any) => void;
    ID: () => string;
    setBackgroundColor: (color: string) => void;
    getOption: (callback: () => any, properties?: undefined) => void;
    setOption: (option: string, notMerge: boolean, lazyUpdate: boolean) => void;
    clear: () => void;
    getWebViewRef: (ref: any) => void;
    onLoadEnd: () => void;
    render(): JSX.Element;
}
export { ECharts };
